<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<!-- saved from url=(0041)http://www.u-aizu.ac.jp/~s1070141/test4.c -->
<HTML><HEAD>
<META http-equiv=Content-Type content="text/html; charset=shift_jis">
<META content="MSHTML 6.00.2800.1106" name=GENERATOR></HEAD>
<BODY><PRE>#define MODULE
#define __KERNEL__

#include &lt;linux/module.h&gt;
//#include &lt;linux/kernel.h&gt;
//#include &lt;linux/sched.h&gt;
//#include &lt;linux/delay.h&gt;


//#define DWORD (unsigned long)

typedef unsigned long DWORD;
DWORD _eax, _ebx, _ecx, _edx;

void test (void);
int CanMSR (void);
void GetVendorID (char * const lpszVendorID);
void Cpuid(DWORD op, DWORD *eax, DWORD *ebx, DWORD *ecx, DWORD *edx);
const unsigned long long __inline__ RDMSR (const DWORD op);
void __inline__ WRMSR (const DWORD op, const DWORD eax, DWORD edx);
void __volatile__ wait (const int wait);

int init_module (void) {
  char szVendorID[13];
  printk ("=&gt; test start\n");
  if (CanMSR ()) {
    printk ("This CPU can use MSR function\n");
  } else {
    printk ("This CPU cannot use MSR function\n");
    return 1;
  }

  szVendorID[12] = '\0';
  GetVendorID (szVendorID);
  printk ("VendorID: %s\n", szVendorID);

  unsigned long long counter;

  const DWORD op = 0x10;

  printk ("             \t= %llu\n", RDMSR(op));

  WRMSR(op, 0, 0);
  printk ("after 1 WRMSR\t= %llu clock(s)\n", RDMSR (op));
  WRMSR(op, 0, 0);
  WRMSR(op, 0, 0);
  printk ("\nafter 2 WRMSR\t= %llu clock(s)\n", RDMSR (op));
  printk ("next printk   \t= %llu clock(s)\n", RDMSR (op));
  printk ("next printk   \t= %llu clock(s)\n", RDMSR (op));
  printk ("next printk   \t= %llu clock(s)\n", RDMSR (op));
  printk ("next printk   \t= %llu clock(s)\n", RDMSR (op));
  WRMSR(op, 0, 0);
  WRMSR(op, 0, 0);
  WRMSR(op, 0, 0);
  printk ("\nafter 3 WRMSR\t= %llu clock(s)\n", RDMSR (op));
  printk ("next printk   \t= %llu clock(s)\n", RDMSR (op));
  printk ("next printk   \t= %llu clock(s)\n", RDMSR (op));
  printk ("next printk   \t= %llu clock(s)\n", RDMSR (op));
  printk ("next printk   \t= %llu clock(s)\n\n", RDMSR (op));

  int loop = 256;
  unsigned long long timer = 0;
  int i;
  for (i=0; i&lt;loop; i++) {
    WRMSR(op, 0, 0);
    timer += RDMSR(op);
  }
  printk ("1 printk + 256 times loops overhead + 256 times WRMSR, RDMSR avarage clock = %llu clock(s)\n", timer &gt;&gt; 8);

  WRMSR(op, 0, 0);
  wait (100);
  printk ("after 100 nop(s) \t= %llu clock(s)\n", RDMSR (op));

  WRMSR(op, 0, 0);
  wait (1000);
  printk ("after 1000 nop(s)\t= %llu clock(s)\n", RDMSR (op));

  WRMSR(op, 0, 0);
  wait (10000);
  printk ("after 10000 nop(s)\t= %llu clock(s)\n", RDMSR (op));

  WRMSR(op, 0, 0);
  wait (100000);
  printk ("after 100000 nop(s)\t= %llu clock(s)\n", RDMSR (op));

  printk ("                \t= %llu\n\n", RDMSR(op));


  int j ;
  for (j =  100; j &lt; 1000000; j *= 10) {
    timer = 0;
    WRMSR(op, 0, 0);
    for (i=0; i&lt;loop; i++) {
      WRMSR(op, 0, 0);
      wait (j);
      timer += RDMSR(op);
    }
    printk ("1 printk + 256 times loops overhead + %lu nops + 256 times WRMSR, RDMSR avarage clock = %llu clock(s)\n", j, timer &gt;&gt; 8);
  }
  return 0;
}

void __volatile__ wait (const int wait){
  int i;
  for (i = 0; i &lt; wait; i++) {
    __asm__ __volatile__ ("nop" \
			  );
  }
}

void cleanup_module (void) {
  printk ("&lt;= test end\n");
}

const unsigned long long __inline__ RDMSR (const DWORD op) {
  __asm__ __volatile__ ("rdmsr" \
			: "=a" (_eax),
			"=d" (_edx)
			: "c" (op)
			);
  const unsigned long long counter = (unsigned long long)(_edx &lt;&lt; 32) + ((unsigned long long)_eax);
  //  printk ("%llu\n", counter);
  return counter;
}

void __inline__ WRMSR (const DWORD op, const DWORD eax, DWORD edx) {
  __asm__ __volatile__ ("wrmsr" \
			:
			: "a" (eax),
			"d" (edx),
			"c" (op)
			);
}

void Cpuid(DWORD op, DWORD *eax, DWORD *ebx, DWORD *ecx, DWORD *edx) {
  __asm__ __volatile__ ("cpuid" \
			: "=a" (_eax),
			"=b" (_ebx),
			"=c" (_ecx),
			"=d" (_edx)
			: "a" (op));
  *eax = _eax;
  *ebx = _ebx;
  *ecx = _ecx;
  *edx = _edx;
}

void test (void) {
  unsigned long hoge = 10;
  unsigned long huga = 1;
  printk ("hoge: %lu, huga: %lu\n", hoge, huga);
  __asm__ __volatile__ ("mov %1, %%eax;" \
	   "mov %%eax, %0;" \
	   : "=r" (huga)
	   : "r" (hoge)
	   : "%eax");
  printk ("hoge: %lu, huga: %lu\n", hoge, huga);
  __asm__ __volatile__ ("mov $123456789, %%eax;" \
	   "mov %%eax, %0;" \
	   : "=r" (huga)
	   : "r" (hoge)
	   : "%eax");
  printk ("hoge: %lu, huga: %lu\n", hoge, huga);
}

int CanMSR (void) {
  Cpuid (1, &amp;_eax, &amp;_ebx, &amp;_ecx, &amp;_edx);
  if (_edx &amp; 1 &lt;&lt; 5) {
    return 1;  // true
  } else {
    return 0;  // false
  }
  //  printk ("EDX: %08X\n", _edx);

  /*
  unsigned long EDX;
  __asm__ __volatile__ ("mov $1, %%eax;" \
	   "cpuid;" \
	   "mov %%edx, %0;" \
	   : "=r" (EDX));
  printk ("EDX: %08X\n", EDX);
  */
  return 0;
}

void GetVendorID (char * const lpszVendorID) {
  /*
  unsigned long *EBX, *ECX, *EDX;
  EBX = (unsigned long*)lpszVendorID;
  EDX = EBX + 1;
  ECX = EDX + 1;
  __asm__ __volatile__ ("movl $0, %%eax;" \
	   "cpuid;" \
	   "movl %%ebx, %0;" \
	   "movl %%edx, %1;" \
	   "movl %%ecx, %2;" \
	   : "=r" (*EBX) \
	   : "=r" (*EDX) \
	   : "=r" (*ECX) \
	   : "%eax");
  */
  DWORD a, *b, *c, *d;
  b = (unsigned long*)lpszVendorID;
  d = b + 1;
  c = d + 1;
  Cpuid (0, &amp;a, b, c, d);
}
</PRE></BODY></HTML>
